Set Implicit Arguments.
Require Import MyTactics.
Require Import AllocationMaps.
Require Import Syntax.

(* ---------------------------------------------------------------------------- *)

(* A (concrete) lock heap is an allocation map. It keeps track of which locks
   have been allocated, and for each allocated lock, records whether this
   lock is currently taken. *)

Inductive lock_status :=
| UNLOCKED
| LOCKED.

Definition lock_heap := aMap lock_status.

(* ---------------------------------------------------------------------------- *)

(* The empty lock heap. *)

Definition empty_lock_heap : lock_heap :=
  (empty_map _).

