Set Implicit Arguments.
Generalizable All Variables.
Require Import MyTactics.
Require Import MyProofIrrelevance.
Require Import MSA.
Require Import MSAProduct.
Require Import MSASig.

(* This tactic helps expand meta-variables in the goal. See also the
   hint database [explode], defined by [MSAProduct] and [MSASig]. *)

Ltac explode :=
  repeat match goal with
  | |- star _ _ = (_, _) => rewrite @msa_pair_star; f_equal
  | |- core _ = (_, _) => rewrite @msa_pair_core; f_equal
  | |- rely (_, _) _ => rewrite @msa_pair_rely; split
  | |- consistent (_, _) => rewrite @msa_pair_consistent; split
  | |- star _ _ = exist _ _ _ => rewrite @msa_sig_star; exist_exist_goal
  | |- core _ = exist _ _ _ => rewrite @msa_sig_core; exist_exist_goal
  | |- rely (exist _ _ _) _ => rewrite @msa_sig_rely
  | |- consistent (exist _ _ _) => rewrite @msa_sig_consistent
  | |- (_, _) = (_, _) => f_equal
  | |- exist _ _ _ = exist _ _ _ => exist_exist_goal
  | |- _ /\ _ => split
  | |- _ = _ => reflexivity
  | |- True => tauto
  end.

