Set Implicit Arguments.
Require Import MSA.

(* ------------------------------------------------------------------------- *)

(* The natural integers, equipped with addition, form a monotonic separation
   algebra, which can be used (for instance) to represent time credits. *)

(* Note that one could also equip them with [max] to form another algebra,
   where every element is duplicable, but some are more informative than
   others. *)

Obligation Tactic := intuition (subst; eauto with omega).

Program Instance msa_nat : MSA nat := {
  star n1 n2 := n1 + n2;
  consistent n := True;
  core n := 0;
  rely n1 n2 := n1 = n2
}.

Global Opaque msa_nat.

