Set Implicit Arguments.
Require Import MyLogic.
Require Import MyTactics.
Require Import DeBruijn.
Require Import Environments.
Require Import Syntax.
Require Import Sugar.
Require Import WellKindedness.
Require Import Heaps.
Require Import LockHeaps.
Require Import Configurations.
Require Import EvaluationContexts.
Require Import Reduction.
Require Import Dup.
Require Import Harmless.
Require Import Resources.
Require Import Row.
Require Import Typing.
Require Import JBasic.
Require Import JWeakening.
Require Import JSubstitution.
Require Import JStrengthening.
Require Import DerivedSubtyping.
Require Import DerivedTyping.
Require Import JAffinity.
Require Import JTop.
Require Import JDecomposition.
Require Import JClassification.
Require Import SubsumptionSoundness.
Require Import JCanonicalization.
Require Import HiddenInvariants.
Require Import Agreement.
Require Import SubjectReductionAuxiliary.

(* ---------------------------------------------------------------------------- *)

(* Subject reduction for [TAcquire]. *)

Lemma subject_reduction_TAcquire:
  forall s1 v s2 t2,
  redwkc (Cf s1 (TAcquire v)) (Cf s2 t2) TERM ->
  forall R R',
  jsr s1 (star R R') ->
  forall K P,
  jctop R K v (TyLock P) ->
  sr_target R' K (Cf s2 t2) (TyMixStar TyTop (TyStar P (TyAnchored v TyLocked))).
Proof.
  intros. redwkc_inversion. jsr_consistent. decomposition.
  destruct_states. explode_resources_locks.
  (* By taking the lock, we acquire its invariant. *)
  forwards: jsr_acquire;
    eauto using invariant_affine with explode_resources aac_guess.
  unpack. explode_resources_locks. maps_star_inversion_aatomic.
  (* Split. *)
  eapply SrTargetCanonical; [ eassumption | | eapply rely_reflexive | ].
  (* Sub-goal 2. *)
  msa_pair. explode;
  try rewrite <- @star_update_core_left by assumption;
  aac_guess.
  (* Sub-goal 4. *)
  match goal with h: maps _ _ _ |- _ => clear h end.
  eapply JcTopMix. eauto with wk.
  econstructor.
    eauto using jpi_zilch_weakening.
    jctop JLocked. eauto using update_taken with getpair.
    eauto with explode aac_guess aac.
Qed.

