Set Implicit Arguments.
Require Import Relation_Operators.
Require Import MyLogic.
Require Import MyTactics.
Require Import DeBruijn.
Require Import Environments.
Require Import Syntax.
Require Import Sugar.
Require Import WellKindedness.
Require Import Configurations.
Require Import EvaluationContexts.
Require Import Reduction.
Require Import Dup.
Require Import Harmless.
Require Import Resources.
Require Import Row.
Require Import Typing.
Require Import JConf.
Require Import SubjectReductionSoups.
Require Import ProgressSoups.
Require Import DataRaceFreedom.

(* ---------------------------------------------------------------------------- *)

(* The final (?) type soundness statement. *)

(* If the source program [t] is well-typed, then the initial configuration,
   which consists of a single thread, about to execute [t], in the initial
   state, can only lead to acceptable and data-race-free configurations,
   regardless of how long one lets the program run. *)

Lemma type_soundness:
  forall n t T,
  jt n void zilch TyEmpty t T ->
  forall c,
  redstar (Cf initial (TThread t)) c ->
  acceptable c /\ data_race_free c.
Proof.
  assert (forall c1 c2, redstar c1 c2 -> jconf c1 -> jconf c2).
    induction 1; eauto using subject_reduction.
  eauto 8 using jconf_initial, progress, data_race_freedom.
Qed.

